/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 1 "grammar.y"


#include "config.h"

#include <errno.h>
#include <fcntl.h>
#include <grp.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <pwd.h>

#ifdef HAVE_RPC_RPC_H
# include <rpc/rpc.h>
#endif
#ifdef HAVE_RPC_PMAP_CLNT_H
# include <rpc/pmap_clnt.h>
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sysexits.h>
#include <syslog.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <regex.h>

#include "installpaths.h"
#include "port/port.h"

#if HAVE_DIRENT_H
# include <dirent.h>
# define NAMLEN(dirent) strlen((dirent)->d_name)
#else
# define dirent direct
# define NAMLEN(dirent) (dirent)->d_namlen
# if HAVE_SYS_NDIR_H
#  include <sys/ndir.h>
# endif
# if HAVE_SYS_DIR_H
#  include <sys/dir.h>
# endif
# if HAVE_NDIR_H
#  include <ndir.h>
# endif
#endif

#ifdef HAVE_NET_BPF_H
# include <net/bpf.h>
#endif

#include "assemble.h"
#include "bytecode.h"
#include "data.h"
#include "db.h"
#include "error.h"
#include "parse.h"
#include "rlinetd.h"
#include "signals.h"
#include "util.h"

#define RL_PWARN(x...)			rl_pwarn(curfile_name, curfile_line, x)
#define RL_PFATAL(x,y...)		rl_pfatal(x, curfile_name, curfile_line, y)

struct userdata *userdata;

static struct service *current_service;
extern FILE *yyin;
extern char *rl_config;
char **files = NULL;
static int curfile = -1, numfiles = 0;
char *curfile_name = NULL;  /* name of the current file */
int curfile_line = 1;					 /* line */

static struct service *defaults;
static struct opmetalist *opml_defaults;

static struct logdata *logcur, *logdatas;

static struct numlist *numlist = NULL;
static struct stringlist *stringlist = NULL;

void yyerror(char *c);
int yylex();
static int bind_ports();
static int add_user_group(const struct service* current_service, struct opmetalist * l);
static void service_copy(struct service *to, struct service *from);
static void service_free(struct service *s);
static struct service *service_new();
#ifndef HAVE_GETADDRINFO
static int getservport(char *str, char *proto);
#endif
static struct logdata *logdata_get(char *name);
static struct logdata *logdata_new();
static void pidtab_fixup();
static void validate_service(struct service *s);
static void add_directory(char *dir, char *match, char *ignore);
static int chargen_buffer();

void freebufs(); /* from parse.l */



/* Line 268 of yacc.c  */
#line 178 "grammar.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     T_SERVICE = 258,
     T_PORT = 259,
     T_EXEC = 260,
     T_PROTO = 261,
     T_UDP = 262,
     T_TCP = 263,
     T_UID = 264,
     T_GID = 265,
     T_BACKLOG = 266,
     T_INSTANCES = 267,
     T_WAIT = 268,
     T_DEFAULT = 269,
     T_NICE = 270,
     T_INTERFACE = 271,
     T_FISH = 272,
     T_CHROOT = 273,
     T_SERVER = 274,
     T_DIR = 275,
     T_RPC = 276,
     T_VERSION = 277,
     T_NAME = 278,
     T_WRAP = 279,
     T_CAPS = 280,
     T_FAMILY = 281,
     T_IPV4 = 282,
     T_IPV6 = 283,
     T_INITGROUPS = 284,
     T_BANNER = 285,
     T_ECHO = 286,
     T_DISCARD = 287,
     T_FILTER = 288,
     T_CHARGEN = 289,
     T_LOOPBACK = 290,
     T_ENABLED = 291,
     T_RLIMIT = 292,
     T_LIM_CPU = 293,
     T_LIM_FSIZE = 294,
     T_LIM_DATA = 295,
     T_LIM_STACK = 296,
     T_LIM_CORE = 297,
     T_LIM_RSS = 298,
     T_LIM_NPROC = 299,
     T_LIM_NOFILE = 300,
     T_LIM_MEMLOCK = 301,
     T_LIM_INFINITY = 302,
     T_SOFT = 303,
     T_HARD = 304,
     T_YES = 305,
     T_NO = 306,
     T_LOG = 307,
     T_PIPE = 308,
     T_SYSLOG = 309,
     T_PATH = 310,
     T_MODE = 311,
     T_ACCEPT = 312,
     T_DENY = 313,
     T_CLOSE = 314,
     T_EXIT = 315,
     T_NUMERIC = 316,
     T_QSTRING = 317,
     T_IPADDR = 318
   };
#endif
/* Tokens.  */
#define T_SERVICE 258
#define T_PORT 259
#define T_EXEC 260
#define T_PROTO 261
#define T_UDP 262
#define T_TCP 263
#define T_UID 264
#define T_GID 265
#define T_BACKLOG 266
#define T_INSTANCES 267
#define T_WAIT 268
#define T_DEFAULT 269
#define T_NICE 270
#define T_INTERFACE 271
#define T_FISH 272
#define T_CHROOT 273
#define T_SERVER 274
#define T_DIR 275
#define T_RPC 276
#define T_VERSION 277
#define T_NAME 278
#define T_WRAP 279
#define T_CAPS 280
#define T_FAMILY 281
#define T_IPV4 282
#define T_IPV6 283
#define T_INITGROUPS 284
#define T_BANNER 285
#define T_ECHO 286
#define T_DISCARD 287
#define T_FILTER 288
#define T_CHARGEN 289
#define T_LOOPBACK 290
#define T_ENABLED 291
#define T_RLIMIT 292
#define T_LIM_CPU 293
#define T_LIM_FSIZE 294
#define T_LIM_DATA 295
#define T_LIM_STACK 296
#define T_LIM_CORE 297
#define T_LIM_RSS 298
#define T_LIM_NPROC 299
#define T_LIM_NOFILE 300
#define T_LIM_MEMLOCK 301
#define T_LIM_INFINITY 302
#define T_SOFT 303
#define T_HARD 304
#define T_YES 305
#define T_NO 306
#define T_LOG 307
#define T_PIPE 308
#define T_SYSLOG 309
#define T_PATH 310
#define T_MODE 311
#define T_ACCEPT 312
#define T_DENY 313
#define T_CLOSE 314
#define T_EXIT 315
#define T_NUMERIC 316
#define T_QSTRING 317
#define T_IPADDR 318




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 107 "grammar.y"

	long num;
	char *cp;
	struct passwd *uid;
	struct group *gid;
	struct opmetalist *opml;
	struct opmeta *opm;
	rlim_t rl;



/* Line 293 of yacc.c  */
#line 352 "grammar.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 364 "grammar.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  15
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   313

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  69
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  35
/* YYNRULES -- Number of rules.  */
#define YYNRULES  112
/* YYNRULES -- Number of states.  */
#define YYNSTATES  213

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   318

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    67,    68,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    64,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    65,     2,    66,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    12,    14,    16,    20,
      25,    31,    37,    39,    41,    44,    46,    50,    54,    58,
      62,    67,    73,    75,    78,    80,    83,    86,    88,    90,
      92,    95,    98,   102,   106,   109,   113,   117,   120,   124,
     129,   133,   137,   142,   146,   150,   154,   160,   165,   169,
     172,   175,   178,   182,   185,   188,   189,   191,   193,   197,
     201,   205,   209,   213,   217,   221,   225,   230,   234,   238,
     240,   243,   247,   251,   253,   257,   259,   263,   265,   268,
     272,   276,   278,   282,   284,   286,   290,   292,   294,   297,
     301,   303,   305,   307,   309,   311,   313,   315,   317,   319,
     321,   323,   325,   327,   329,   331,   333,   335,   337,   339,
     341,   344,   346
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      70,     0,    -1,    71,    -1,    70,    71,    -1,    78,    -1,
      77,    -1,    73,    -1,    72,    -1,    20,    62,    64,    -1,
      20,    62,    62,    64,    -1,    20,    62,    62,    62,    64,
      -1,    52,    62,    65,    74,    66,    -1,    75,    -1,    76,
      -1,    75,    76,    -1,    64,    -1,    55,    62,    64,    -1,
       9,    98,    64,    -1,    10,    99,    64,    -1,    56,    61,
      64,    -1,    14,    65,    79,    66,    -1,     3,    62,    65,
      79,    66,    -1,    84,    -1,    79,    84,    -1,    82,    -1,
      79,    82,    -1,    79,    81,    -1,    81,    -1,    81,    -1,
      82,    -1,    80,    82,    -1,    80,    81,    -1,     5,    62,
      64,    -1,     9,    98,    64,    -1,    29,    64,    -1,    29,
     103,    64,    -1,    15,   102,    64,    -1,    17,    64,    -1,
      37,    97,    95,    -1,    52,    54,    62,    64,    -1,    30,
      62,    64,    -1,    34,    83,    64,    -1,    52,    62,    62,
      64,    -1,    10,    99,    64,    -1,    18,    62,    64,    -1,
      25,    62,    64,    -1,    24,    62,    65,    80,    66,    -1,
      24,    65,    80,    66,    -1,    24,    62,    64,    -1,    24,
      64,    -1,    59,    64,    -1,    60,    64,    -1,    31,    62,
      64,    -1,    35,    64,    -1,    32,    64,    -1,    -1,    62,
      -1,    64,    -1,     4,    93,    64,    -1,     6,   100,    64,
      -1,    11,    61,    64,    -1,    12,    61,    64,    -1,    13,
     103,    64,    -1,    36,   103,    64,    -1,    16,    91,    64,
      -1,    19,    62,    64,    -1,    21,    65,    85,    66,    -1,
      26,   101,    64,    -1,    33,    62,    64,    -1,    86,    -1,
      85,    86,    -1,    23,    62,    64,    -1,    22,    87,    64,
      -1,    88,    -1,    87,    67,    88,    -1,    61,    -1,    61,
      68,    61,    -1,    90,    -1,    89,    90,    -1,    48,    96,
      64,    -1,    49,    96,    64,    -1,    92,    -1,    91,    67,
      92,    -1,    63,    -1,    94,    -1,    93,    67,    94,    -1,
      62,    -1,    61,    -1,    96,    64,    -1,    65,    89,    66,
      -1,    61,    -1,    47,    -1,    38,    -1,    39,    -1,    40,
      -1,    41,    -1,    42,    -1,    43,    -1,    44,    -1,    45,
      -1,    46,    -1,    61,    -1,    62,    -1,    61,    -1,    62,
      -1,     8,    -1,     7,    -1,    27,    -1,    28,    -1,    61,
      -1,    68,    61,    -1,    50,    -1,    51,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   147,   147,   148,   151,   152,   153,   154,   157,   159,
     161,   165,   180,   206,   207,   210,   211,   222,   230,   238,
     249,   267,   397,   401,   405,   416,   424,   432,   438,   442,
     453,   461,   471,   492,   513,   520,   530,   534,   538,   542,
     550,   562,   582,   596,   610,   614,   629,   644,   661,   678,
     697,   701,   705,   709,   719,   729,   730,   733,   734,   741,
     745,   749,   753,   757,   761,   768,   773,   774,   775,   790,
     791,   794,   798,   805,   806,   809,   813,   823,   824,   827,
     831,   837,   838,   841,   847,   848,   851,   855,   865,   869,
     880,   882,   886,   895,   904,   913,   922,   931,   940,   949,
     958,   968,   973,   981,   986,   994,  1000,  1008,  1012,  1023,
    1027,  1033,  1037
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "T_SERVICE", "T_PORT", "T_EXEC",
  "T_PROTO", "T_UDP", "T_TCP", "T_UID", "T_GID", "T_BACKLOG",
  "T_INSTANCES", "T_WAIT", "T_DEFAULT", "T_NICE", "T_INTERFACE", "T_FISH",
  "T_CHROOT", "T_SERVER", "T_DIR", "T_RPC", "T_VERSION", "T_NAME",
  "T_WRAP", "T_CAPS", "T_FAMILY", "T_IPV4", "T_IPV6", "T_INITGROUPS",
  "T_BANNER", "T_ECHO", "T_DISCARD", "T_FILTER", "T_CHARGEN", "T_LOOPBACK",
  "T_ENABLED", "T_RLIMIT", "T_LIM_CPU", "T_LIM_FSIZE", "T_LIM_DATA",
  "T_LIM_STACK", "T_LIM_CORE", "T_LIM_RSS", "T_LIM_NPROC", "T_LIM_NOFILE",
  "T_LIM_MEMLOCK", "T_LIM_INFINITY", "T_SOFT", "T_HARD", "T_YES", "T_NO",
  "T_LOG", "T_PIPE", "T_SYSLOG", "T_PATH", "T_MODE", "T_ACCEPT", "T_DENY",
  "T_CLOSE", "T_EXIT", "T_NUMERIC", "T_QSTRING", "T_IPADDR", "';'", "'{'",
  "'}'", "','", "'-'", "$accept", "tles", "tle", "directory", "log",
  "log_element", "file_elements", "file_element", "default", "service",
  "service_elements", "opcode_block", "complex_opcode_element",
  "opcode_element", "optionalstring", "service_element", "rpcents",
  "rpcent", "numrangelist", "numrange", "limitents", "limitent",
  "ipaddrlists", "ipaddrlist", "portlists", "portlist", "limit",
  "limitvalue", "limittype", "userid", "groupid", "protocol", "family",
  "signed_numeric", "boolean", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    59,   123,   125,    44,    45
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    69,    70,    70,    71,    71,    71,    71,    72,    72,
      72,    73,    74,    75,    75,    76,    76,    76,    76,    76,
      77,    78,    79,    79,    79,    79,    79,    79,    80,    80,
      80,    80,    81,    81,    81,    81,    82,    82,    82,    82,
      82,    82,    82,    82,    82,    82,    82,    82,    82,    82,
      82,    82,    82,    82,    82,    83,    83,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    85,
      85,    86,    86,    87,    87,    88,    88,    89,    89,    90,
      90,    91,    91,    92,    93,    93,    94,    94,    95,    95,
      96,    96,    97,    97,    97,    97,    97,    97,    97,    97,
      97,    98,    98,    99,    99,   100,   100,   101,   101,   102,
     102,   103,   103
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     3,     4,
       5,     5,     1,     1,     2,     1,     3,     3,     3,     3,
       4,     5,     1,     2,     1,     2,     2,     1,     1,     1,
       2,     2,     3,     3,     2,     3,     3,     2,     3,     4,
       3,     3,     4,     3,     3,     3,     5,     4,     3,     2,
       2,     2,     3,     2,     2,     0,     1,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     4,     3,     3,     1,
       2,     3,     3,     1,     3,     1,     3,     1,     2,     3,
       3,     1,     3,     1,     1,     3,     1,     1,     2,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     2,     7,     6,     5,
       4,     0,     0,     0,     0,     1,     3,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      55,     0,     0,     0,     0,     0,     0,    57,     0,    27,
      24,    22,     0,     8,     0,     0,    87,    86,     0,    84,
       0,   106,   105,     0,   101,   102,     0,   103,   104,     0,
       0,     0,   111,   112,     0,   109,     0,     0,    83,     0,
      81,    37,     0,     0,     0,     0,    49,     0,     0,   107,
     108,     0,    34,     0,     0,     0,    54,     0,    56,     0,
      53,     0,    92,    93,    94,    95,    96,    97,    98,    99,
     100,     0,     0,     0,    50,    51,    20,    26,    25,    23,
       0,     9,     0,     0,     0,     0,    15,     0,    12,    13,
      21,    58,     0,    32,    59,    33,    43,    60,    61,    62,
     110,    36,    64,     0,    44,    65,     0,     0,     0,    69,
      48,     0,     0,    28,    29,    45,    67,    35,    40,    52,
      68,    41,    63,    91,    90,     0,    38,     0,     0,     0,
      10,     0,     0,     0,     0,    11,    14,    85,    82,    75,
       0,    73,     0,    66,    70,     0,    47,    31,    30,     0,
       0,     0,    77,    88,    39,    42,    17,    18,    16,    19,
       0,    72,     0,    71,    46,     0,     0,    89,    78,    76,
      74,    79,    80
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     5,     6,     7,     8,   127,   128,   129,     9,    10,
      48,   152,    49,    50,    99,    51,   148,   149,   180,   181,
     191,   192,    79,    80,    58,    59,   166,   167,   111,    66,
      69,    63,    91,    77,    74
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -62
static const yytype_int16 yypact[] =
{
      13,   -61,   -54,   -41,   -20,    93,   -62,   -62,   -62,   -62,
     -62,     5,   240,    46,    25,   -62,   -62,   240,    58,   -16,
     148,    63,    96,    23,    34,   111,    -4,    48,    36,    56,
      69,    75,    37,    82,   139,   -45,    97,   101,   104,   109,
     116,   118,   111,   189,   -44,   124,   127,   -62,    19,   -62,
     -62,   -62,    50,   -62,     4,   117,   -62,   -62,   -52,   -62,
     132,   -62,   -62,   140,   -62,   -62,   144,   -62,   -62,   145,
     146,   147,   -62,   -62,   160,   -62,   165,   172,   -62,   -47,
     -62,   -62,   173,   174,   152,   130,   -62,    57,   175,   -62,
     -62,   177,   -62,   178,   179,   196,   -62,   198,   -62,   199,
     -62,   203,   -62,   -62,   -62,   -62,   -62,   -62,   -62,   -62,
     -62,   -39,   154,   206,   -62,   -62,   -62,   -62,   -62,   -62,
     214,   -62,    63,    96,   217,   219,   -62,   215,     4,   -62,
     -62,   -62,    58,   -62,   -62,   -62,   -62,   -62,   -62,   -62,
     -62,   -62,   -62,    48,   -62,   -62,   221,   222,   -19,   -62,
     -62,    57,   155,   -62,   -62,   -62,   -62,   -62,   -62,   -62,
     -62,   -62,   -62,   -62,   -62,   151,   -62,   223,   224,   225,
     -62,   226,   227,   229,   230,   -62,   -62,   -62,   -62,   218,
      -6,   -62,   231,   -62,   -62,   188,   -62,   -62,   -62,    16,
      16,    49,   -62,   -62,   -62,   -62,   -62,   -62,   -62,   -62,
     235,   -62,   221,   -62,   -62,   233,   234,   -62,   -62,   -62,
     -62,   -62,   -62
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -62,   -62,   278,   -62,   -62,   -62,   -62,   157,   -62,   -62,
     284,   156,   -48,   -46,   -62,    21,   -62,   158,   -62,   100,
     -62,   112,   -62,   162,   -62,   176,   -62,    12,   -62,   187,
     190,   -62,   -62,   -62,    38
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
     117,    11,   118,   146,   147,    72,    73,   117,   163,   118,
     112,    12,   131,   122,   123,   132,     1,   142,   113,    92,
     143,    13,   164,    18,    19,    20,   165,     2,    21,    22,
      23,    24,    25,     3,    26,    27,    28,    29,    30,   153,
      31,   154,    14,    32,    33,    34,    60,   183,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    75,   201,   124,
     125,   202,    19,   163,    76,     4,    21,    22,   126,   119,
      17,    44,    26,    93,    28,    29,   119,   164,    45,    46,
     101,    32,    33,    47,    70,   116,    35,    36,    37,    38,
      54,    40,    41,    15,    43,    71,     1,   189,   190,    85,
      81,    86,    87,   153,   187,   154,   188,     2,    52,    44,
      53,    78,   120,     3,   121,   207,    45,    46,    82,    56,
      57,    18,    19,    20,    64,    65,    21,    22,    23,    24,
      25,    83,    26,    27,    28,    29,    30,   187,    31,   188,
      84,    32,    33,    34,    88,     4,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    61,    62,    67,    68,    94,
      19,    72,    73,    95,    21,    22,    89,    90,    96,    44,
      26,    97,    28,    29,   146,   147,    45,    46,    98,    32,
      33,    47,   100,   130,    35,    36,    37,    38,   114,    40,
      41,   115,    43,    19,   150,   151,   133,    21,    22,   189,
     190,   205,   206,    26,   134,    28,    29,    44,   135,   136,
     137,   138,    32,    33,    45,    46,   168,    35,    36,    37,
      38,   186,    40,    41,   139,    43,   140,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   141,   144,   145,   155,
      44,   156,   157,   158,    18,    19,    20,    45,    46,    21,
      22,    23,    24,    25,   204,    26,    27,    28,    29,    30,
     159,    31,   160,   161,    32,    33,    34,   162,   169,    35,
      36,    37,    38,    39,    40,    41,    42,    43,   170,   173,
     174,   175,   179,    16,   182,   176,   200,   193,   194,   195,
     196,   197,    44,   198,   199,   203,   209,   211,   212,    45,
      46,    55,   210,   208,    47,   178,   184,   185,   177,   171,
       0,     0,     0,   172
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-62))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
      48,    62,    48,    22,    23,    50,    51,    55,    47,    55,
      54,    65,    64,     9,    10,    67,     3,    64,    62,    64,
      67,    62,    61,     4,     5,     6,    65,    14,     9,    10,
      11,    12,    13,    20,    15,    16,    17,    18,    19,    87,
      21,    87,    62,    24,    25,    26,    62,    66,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    61,    64,    55,
      56,    67,     5,    47,    68,    52,     9,    10,    64,    48,
      65,    52,    15,    35,    17,    18,    55,    61,    59,    60,
      42,    24,    25,    64,    61,    66,    29,    30,    31,    32,
      65,    34,    35,     0,    37,    61,     3,    48,    49,    62,
      64,    64,    65,   151,   152,   151,   152,    14,    62,    52,
      64,    63,    62,    20,    64,    66,    59,    60,    62,    61,
      62,     4,     5,     6,    61,    62,     9,    10,    11,    12,
      13,    62,    15,    16,    17,    18,    19,   185,    21,   185,
      65,    24,    25,    26,    62,    52,    29,    30,    31,    32,
      33,    34,    35,    36,    37,     7,     8,    61,    62,    62,
       5,    50,    51,    62,     9,    10,    27,    28,    64,    52,
      15,    62,    17,    18,    22,    23,    59,    60,    62,    24,
      25,    64,    64,    66,    29,    30,    31,    32,    64,    34,
      35,    64,    37,     5,    64,    65,    64,     9,    10,    48,
      49,   189,   190,    15,    64,    17,    18,    52,    64,    64,
      64,    64,    24,    25,    59,    60,    62,    29,    30,    31,
      32,    66,    34,    35,    64,    37,    61,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    64,    64,    64,    64,
      52,    64,    64,    64,     4,     5,     6,    59,    60,     9,
      10,    11,    12,    13,    66,    15,    16,    17,    18,    19,
      64,    21,    64,    64,    24,    25,    26,    64,    62,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    64,    62,
      61,    66,    61,     5,    62,   128,    68,    64,    64,    64,
      64,    64,    52,    64,    64,    64,    61,    64,    64,    59,
      60,    17,   202,   191,    64,   143,   148,   151,   132,   122,
      -1,    -1,    -1,   123
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,    14,    20,    52,    70,    71,    72,    73,    77,
      78,    62,    65,    62,    62,     0,    71,    65,     4,     5,
       6,     9,    10,    11,    12,    13,    15,    16,    17,    18,
      19,    21,    24,    25,    26,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    52,    59,    60,    64,    79,    81,
      82,    84,    62,    64,    65,    79,    61,    62,    93,    94,
      62,     7,     8,   100,    61,    62,    98,    61,    62,    99,
      61,    61,    50,    51,   103,    61,    68,   102,    63,    91,
      92,    64,    62,    62,    65,    62,    64,    65,    62,    27,
      28,   101,    64,   103,    62,    62,    64,    62,    62,    83,
      64,   103,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    97,    54,    62,    64,    64,    66,    81,    82,    84,
      62,    64,     9,    10,    55,    56,    64,    74,    75,    76,
      66,    64,    67,    64,    64,    64,    64,    64,    64,    64,
      61,    64,    64,    67,    64,    64,    22,    23,    85,    86,
      64,    65,    80,    81,    82,    64,    64,    64,    64,    64,
      64,    64,    64,    47,    61,    65,    95,    96,    62,    62,
      64,    98,    99,    62,    61,    66,    76,    94,    92,    61,
      87,    88,    62,    66,    86,    80,    66,    81,    82,    48,
      49,    89,    90,    64,    64,    64,    64,    64,    64,    64,
      68,    64,    67,    64,    66,    96,    96,    66,    90,    61,
      88,    64,    64
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 8:

/* Line 1806 of yacc.c  */
#line 158 "grammar.y"
    {	add_directory((yyvsp[(2) - (3)].cp), NULL, NULL);	}
    break;

  case 9:

/* Line 1806 of yacc.c  */
#line 160 "grammar.y"
    {	add_directory((yyvsp[(2) - (4)].cp), (yyvsp[(3) - (4)].cp), NULL);	}
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 162 "grammar.y"
    {	add_directory((yyvsp[(2) - (5)].cp), (yyvsp[(3) - (5)].cp), (yyvsp[(4) - (5)].cp));	}
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 166 "grammar.y"
    {
		if(logdata_get((yyvsp[(2) - (5)].cp))) {
			RL_PWARN("duplicate declaration of log %s, ignoring", (yyvsp[(2) - (5)].cp));
			free((yyvsp[(2) - (5)].cp));
		} else {
			logcur->name = (yyvsp[(2) - (5)].cp);
			logcur->next = logdatas;
			logdatas = logcur;
			logcur = logdata_new();
		}
		clearuserdata(&userdata);
	}
    break;

  case 12:

/* Line 1806 of yacc.c  */
#line 181 "grammar.y"
    {
		if(!logcur->path) {
			RL_PWARN(_("No path defined for log %s"), logcur->name);
		} else {
			if((logcur->index = open(logcur->path, O_CREAT|O_APPEND|O_WRONLY, logcur->mode)) < 0) {
				RL_PWARN(_("open(\"%s\", O_CREAT|O_APPEND|O_WRONLY, 0%o) failed (%s)"),
								logcur->path, logcur->mode, strerror(errno));
			} else {

				if(fchmod(logcur->index, logcur->mode)) {
					RL_PWARN(_("fchmod(\"%s\", 0%o) failed (%s)"),
									logcur->path, logcur->mode,
									strerror(errno));
				}

				if(fchown(logcur->index, logcur->uid, logcur->gid)) {
					RL_PWARN(_("fchown(\"%s\", %d, %d) failed for log %s (%s)"),
									logcur->path, logcur->uid, logcur->gid, logcur->name,
									strerror(errno));
				}
			}
		}
	}
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 212 "grammar.y"
    {
		if(logcur->path) {
			RL_PWARN(_("duplicate path declaration (%s) "
				"in log directive %s, ignoring"), (yyvsp[(2) - (3)].cp),
				logcur->name);
			free((yyvsp[(2) - (3)].cp));
		} else {
			logcur->path = (yyvsp[(2) - (3)].cp);
		}
	}
    break;

  case 17:

/* Line 1806 of yacc.c  */
#line 223 "grammar.y"
    {
		if ((yyvsp[(2) - (3)].uid)) {
			logcur->uid = (yyvsp[(2) - (3)].uid)->pw_uid;
		} else {
			RL_PWARN("unknown username");
		}
	}
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 231 "grammar.y"
    {
		if ((yyvsp[(2) - (3)].gid)) {
			logcur->gid = (yyvsp[(2) - (3)].gid)->gr_gid;
		} else {
			RL_PWARN("unknown groupname");
		}
	}
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 239 "grammar.y"
    {
		if ((yyvsp[(2) - (3)].num) > 07777)  {
			RL_PWARN(_("invalid mode declaration "
				"in log directive %s, ignoring"), logcur->name);
		} else {
			logcur->mode = (yyvsp[(2) - (3)].num);
		}
	}
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 250 "grammar.y"
    {
		/* swich pointers to current_service and defaults */
		struct service * saved_defaults = defaults;
		defaults = current_service;
		current_service = saved_defaults;

		/* copy new defaults to current_service */
		service_free(current_service);
		service_copy(current_service, defaults);

		/* save default opmetalist */
		opmetalist_free(opml_defaults);
		free(opml_defaults);
		opml_defaults = (yyvsp[(3) - (4)].opml);
	}
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 268 "grammar.y"
    {
		struct opmetalist *parent;
		struct opmetalist *onexit;
		struct oplist *ops;
		int i, bound;
		int fds;
		fd_set *fdst;

		parent = opmetalist_new();
		onexit = opmetalist_new();

		current_service->name = (yyvsp[(2) - (5)].cp);
		current_service->opfixups[ofp_iname] = stringtab_add((yyvsp[(2) - (5)].cp));

		do { /* avoid goto */

			if (current_service->disabled)
				break;

			if(current_service->socktype == SOCK_STREAM && !current_service->wait) {
				if(opmetalist_add((yyvsp[(4) - (5)].opml), opmeta_make(2, OP_ACCEPT, 200))) { /* !200 */
					RL_PWARN(_("opcode resolving problem"));
					current_service->disabled++;
					break;
				}
				opmetalist_add(parent, opmeta_make(1, OP_CLOSE));

				if (current_service->internal)
					opmetalist_add(onexit, opmeta_make(1, OP_CLOSE));
				else
					opmetalist_add(onexit, opmeta_make(1, OP_RET));

			} else {
				opmetalist_add(parent, opmeta_make(1, OP_RET));
				opmetalist_add(onexit, opmeta_make(1, OP_RET));
			}
			validate_service(current_service);


			if (current_service->disabled)
				break;

			if (!add_user_group(current_service, (yyvsp[(4) - (5)].opml)))
			{
				++current_service->disabled;
			  break;
		  }


			fds = bind_ports();


			if(current_service->limit) {
				struct opmetalist *o;
				struct oplist *l;
				int match, under;

				o = opmetalist_new();
				opmetalist_add(o, opmeta_make(2, OP_LCLR, fds));
				opmetalist_add(o, opmeta_make(1, OP_RET));
				l = opmetalist_resolve(o, current_service->opfixups);
				match = oplisttab_add(l);
				opmetalist_free(o);
				free(o);
				oplist_free(l);
				free(l);

				o = opmetalist_new();
				opmetalist_add(o, opmeta_make(2, OP_LSET, fds));
				opmetalist_add(o, opmeta_make(1, OP_RET));
				l = opmetalist_resolve(o, current_service->opfixups);
				under = oplisttab_add(l);
				opmetalist_free(o);
				free(o);
				oplist_free(l);
				free(l);

				i = semaphore_add(current_service->limit, match, under);
				opmetalist_add((yyvsp[(4) - (5)].opml), opmeta_make(2, OP_DOWN, i));
				opmetalist_add(onexit, opmeta_make(2, OP_UP, i));
			}
			ops = opmetalist_resolve(onexit, current_service->opfixups);
			current_service->opfixups[ofp_onexit] = oplisttab_add(ops);
			opmetalist_free(onexit);
			free(onexit);
			oplist_free(ops);
			free(ops);

			ops = opmetalist_resolve(parent, current_service->opfixups);
			current_service->opfixups[ofp_parent] = oplisttab_add(ops);
			opmetalist_free(parent);
			free(parent);
			oplist_free(ops);
			free(ops);

			opmetalist_merge((yyvsp[(4) - (5)].opml), opml_defaults);

			opmetalist_add((yyvsp[(4) - (5)].opml), opmeta_make(2, OP_JUMP, current_service->opfixups[ofp_onexit]));
			ops = opmetalist_resolve((yyvsp[(4) - (5)].opml), current_service->opfixups);

			current_service->run = oplisttab_add(ops);
			opmetalist_free((yyvsp[(4) - (5)].opml));
			free((yyvsp[(4) - (5)].opml));
			oplist_free(ops);
			free(ops);

			fdst = fdsettab_get(fds);
			bound = getdtablesize();
			for(i = 0; i < bound; i++)
				if(FD_ISSET(i, fdst))
					read_hook(i, oplisttab_get(current_service->run), NULL);

		} while (0);

		if (current_service->disabled) {
					rl_warn(_("service %s DISABLED"), current_service->name);
		} else {
			rl_note(_("service %s enabled"), current_service->name);
			if (rl_debug > 1)
				rl_note(_("+-> uid=%d, sgid=%d, supgid=%d fl=%d"), current_service->opfixups[ofp_setuid],
					current_service->opfixups[ofp_setgid], current_service->opfixups[ofp_supgid], current_service->sflags);

		}

		service_free(current_service);
		service_copy(current_service, defaults);
	}
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 398 "grammar.y"
    {
		(yyval.opml) = opmetalist_new();
	}
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 402 "grammar.y"
    {
		(yyval.opml) = (yyvsp[(1) - (2)].opml);
	}
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 406 "grammar.y"
    {
		struct opmetalist *l;

		l = opmetalist_new();
		if(opmetalist_add(l, (yyvsp[(1) - (1)].opm))) {
			RL_PWARN(_("opcode resolving problem"));
			current_service->disabled++;
		}
		(yyval.opml) = l;
	}
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 417 "grammar.y"
    {
		if(opmetalist_add((yyvsp[(1) - (2)].opml), (yyvsp[(2) - (2)].opm))) {
			RL_PWARN(_("opcode resolving problem"));
			current_service->disabled++;
		}
		(yyval.opml) = (yyvsp[(1) - (2)].opml);
	}
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 425 "grammar.y"
    {
		(yyval.opml) = opmetalist_join((yyvsp[(1) - (2)].opml), (yyvsp[(2) - (2)].opml));
		if(!(yyval.opml)) {
			RL_PWARN(_("opcode resolving problem"));
			current_service->disabled++;
		}
	}
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 433 "grammar.y"
    {
		(yyval.opml) = (yyvsp[(1) - (1)].opml);
	}
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 439 "grammar.y"
    {
		(yyval.opml) = (yyvsp[(1) - (1)].opml);
	}
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 443 "grammar.y"
    {
		struct opmetalist *l;

		l = opmetalist_new();
		if(opmetalist_add(l, (yyvsp[(1) - (1)].opm))) {
			RL_PWARN(_("opcode resolving problem"));
			current_service->disabled++;
		}
		(yyval.opml) = l;
	}
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 454 "grammar.y"
    {
		if(opmetalist_add((yyvsp[(1) - (2)].opml), (yyvsp[(2) - (2)].opm))) {
			RL_PWARN(_("opcode resolving problem"));
			current_service->disabled++;
		}
		(yyval.opml) = (yyvsp[(1) - (2)].opml);
	}
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 462 "grammar.y"
    {
		(yyval.opml) = opmetalist_join((yyvsp[(1) - (2)].opml), (yyvsp[(2) - (2)].opml));
		if(!(yyval.opml)) {
			RL_PWARN(_("opcode resolving problem"));
			current_service->disabled++;
		}
	}
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 472 "grammar.y"
    {
		struct opmetalist *l;
		struct opmeta *o;

		l = opmetalist_new();
		o = opmeta_make(3, OP_EXEC, 666, argvtab_add((yyvsp[(2) - (3)].cp), 1));
		opmeta_fixup(o, 1, ofp_exec);
		if(opmetalist_add(l, o)) {
			RL_PWARN(_("opcode resolving problem"));
			current_service->disabled++;
		}
		o = opmeta_make(3, OP_FORK, 666, 666);
		opmeta_fixup(o, 1, ofp_parent);
		opmeta_fixup(o, 2, ofp_onexit);
		if(opmetalist_add(l, o)) {
			RL_PWARN(_("opcode resolving problem"));
			current_service->disabled++;
		}
		(yyval.opml) = l;
	}
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 493 "grammar.y"
    {
		if((yyvsp[(2) - (3)].uid)) {

			current_service->opfixups[ofp_iuser] = stringtab_add((yyvsp[(2) - (3)].uid)->pw_name);
			current_service->opfixups[ofp_setuid] = (yyvsp[(2) - (3)].uid)->pw_uid;
			current_service->opfixups[ofp_supgid] = (yyvsp[(2) - (3)].uid)->pw_gid;

			set_flag(current_service, FLAG_USER);

			if(!has_flag(current_service, FLAG_GROUP)) {
				current_service->opfixups[ofp_setgid] = (yyvsp[(2) - (3)].uid)->pw_gid;
			}

			(yyval.opml) = NULL;
		} else {
			RL_PWARN("unknown username");
			current_service->disabled++;
			(yyval.opml) = NULL;
		}
	}
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 514 "grammar.y"
    {
		set_flag(current_service, FLAG_INITGROUPS);

		(yyval.opml) = NULL;

	}
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 521 "grammar.y"
    {
		if ((yyvsp[(2) - (3)].num))
			set_flag(current_service, FLAG_INITGROUPS);
		else
			reset_flag(current_service, FLAG_INITGROUPS);
		(yyval.opml) = NULL;
	}
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 531 "grammar.y"
    {
		(yyval.opm) = opmeta_make(2, OP_NICE, (yyvsp[(2) - (3)].num));
	}
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 535 "grammar.y"
    {
		(yyval.opm) = opmeta_make(1, OP_FISH);
	}
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 539 "grammar.y"
    {
		(yyval.opm) = opmeta_make(3, OP_RLIMIT, (yyvsp[(2) - (3)].num), (yyvsp[(3) - (3)].num));
	}
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 543 "grammar.y"
    {
		int i;

		i = logtab_add(-1, (yyvsp[(3) - (4)].cp));
		(yyval.opm) = opmeta_make(2, OP_LOG, i);
		free((yyvsp[(3) - (4)].cp));
	}
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 551 "grammar.y"
    {
		int ret;

		ret = buftab_addfile((yyvsp[(2) - (3)].cp));
		if(ret == -1)
			current_service->disabled++;
		(yyval.opm) = opmeta_make(16, OP_ZERO, OP_BUFCLONE, ret, OP_WHOOK, 0, OP_WUNHOOK,
										 OP_DUP, OP_BUFCOPY, OP_DUP, OP_BZNEG, 3, OP_ADD,
										 OP_WHOOK, -9, OP_POP, OP_BUFFREE);
		free((yyvsp[(2) - (3)].cp));
	}
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 563 "grammar.y"
    {
		int i;

		if((yyvsp[(2) - (3)].cp)) {
			i = buftab_addfile((yyvsp[(2) - (3)].cp));
			if(i < 0)
				current_service->disabled++;
		} else {
			i = chargen_buffer();
		}
		(yyval.opm) = opmeta_make(25, OP_ZERO, OP_DUP, OP_BUFCLONE, i, OP_POP,
										 OP_POP, OP_ZERO, OP_WHOOK, 0, OP_WUNHOOK, OP_DUP,
										 OP_BUFCOPY, OP_DUP, OP_BZ, -11, OP_DUP, OP_BZNEG, 3,
										 OP_ADD, OP_WHOOK, -12, OP_POP, OP_BUFFREE, OP_JUMP, 666);
		opmeta_fixup((yyval.opm), 24, ofp_onexit);
		current_service->internal = 1;
		if((yyvsp[(2) - (3)].cp))
			free((yyvsp[(2) - (3)].cp));
	}
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 583 "grammar.y"
    {
		struct logdata *ld = logdata_get((yyvsp[(2) - (4)].cp));

		if(!ld) {
			RL_PWARN(_("unknown log %s"), (yyvsp[(2) - (4)].cp));
			current_service->disabled++;
		} else {
			int i = logtab_add(ld->index, (yyvsp[(3) - (4)].cp));
			(yyval.opm) = opmeta_make(2, OP_LOG, i);
		}
		free((yyvsp[(2) - (4)].cp));
		free((yyvsp[(3) - (4)].cp));
	}
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 597 "grammar.y"
    {
		if(!(yyvsp[(2) - (3)].gid)) {
			RL_PWARN(_("unknown group"));
			current_service->disabled++;
			(yyval.opm) = NULL;
		} else {

			current_service->opfixups[ofp_setgid] = (yyvsp[(2) - (3)].gid)->gr_gid;
			set_flag(current_service, FLAG_GROUP);

			(yyval.opm) = NULL;
		}
	}
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 611 "grammar.y"
    {
		(yyval.opm) = opmeta_make(2, OP_CHROOT, argvtab_add((yyvsp[(2) - (3)].cp), 1));
	}
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 615 "grammar.y"
    {
#ifdef HAVE_CAPABILITIES
		cap_t caps = cap_from_text((yyvsp[(2) - (3)].cp));
		if(caps) {
			(yyval.opm) = opmeta_make(2, OP_SETCAP, captab_add(caps));
		} else {
			RL_PWARN(_("failed to parse capability string \"%s\"\n"), (yyvsp[(2) - (3)].cp));
			current_service->disabled++;
		}
		free((yyvsp[(2) - (3)].cp));
#else
		RL_PFATAL(EX_DATAERR, _("ABORT - support for capabilities not compiled in"));
#endif
	}
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 630 "grammar.y"
    {
		int i;
		struct oplist *op;

		opmetalist_add((yyvsp[(4) - (5)].opml), opmeta_make(1, OP_RET));
		op = opmetalist_resolve((yyvsp[(4) - (5)].opml),current_service->opfixups);
		i = oplisttab_add(op);
		(yyval.opm) = opmeta_make(3, OP_WRAP, stringtab_add((yyvsp[(2) - (5)].cp)), i);
		free((yyvsp[(2) - (5)].cp));
		oplist_free(op);
		free(op);
		opmetalist_free((yyvsp[(4) - (5)].opml));
		free((yyvsp[(4) - (5)].opml));
	}
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 645 "grammar.y"
    {
		struct opmeta *o;
		int i;
		struct oplist *op;

		opmetalist_add((yyvsp[(3) - (4)].opml), opmeta_make(1, OP_RET));
		op = opmetalist_resolve((yyvsp[(3) - (4)].opml), current_service->opfixups);
		i = oplisttab_add(op);
		o = opmeta_make(3, OP_WRAP, 666, i);
		opmeta_fixup(o, 1, ofp_iname);
		(yyval.opm) = o;
		oplist_free(op);
		free(op);
		opmetalist_free((yyvsp[(3) - (4)].opml));
		free((yyvsp[(3) - (4)].opml));
	}
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 662 "grammar.y"
    {
		struct opmetalist *l;
		int i;
		struct oplist *op;

		l = opmetalist_new();
		opmetalist_add(l, opmeta_make(1, OP_EXIT));
		op = opmetalist_resolve(l, current_service->opfixups);
		i = oplisttab_add(op);
		(yyval.opm) = opmeta_make(3, OP_WRAP, stringtab_add((yyvsp[(2) - (3)].cp)), i);
		free((yyvsp[(2) - (3)].cp));
		oplist_free(op);
		free(op);
		opmetalist_free(l);
		free(l);
	}
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 679 "grammar.y"
    {
		struct opmetalist *l;
		struct opmeta *o;
		int i;
		struct oplist *op;

		l = opmetalist_new();
		opmetalist_add(l, opmeta_make(1, OP_EXIT));
		op = opmetalist_resolve(l,current_service->opfixups);
		i = oplisttab_add(op);
		o = opmeta_make(3, OP_WRAP, 666, i);
		opmeta_fixup(o, 1, ofp_iname);
		(yyval.opm) = o;
		oplist_free(op);
		free(op);
		opmetalist_free(l);
		free(l);
	}
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 698 "grammar.y"
    {
		(yyval.opm) = opmeta_make(1, OP_CLOSE);
	}
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 702 "grammar.y"
    {
		(yyval.opm) = opmeta_make(1, OP_EXIT);
	}
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 706 "grammar.y"
    {
		(yyval.opm) = opmeta_make(2, OP_ECHO, argvtab_add((yyvsp[(2) - (3)].cp), 0));
	}
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 710 "grammar.y"
    {
		(yyval.opm) = opmeta_make(29, OP_ZERO, OP_BUFINIT, 11, OP_RHOOK, 0, OP_BUFREAD,
										 OP_RUNHOOK, OP_DUP, OP_BZNEG, 17, OP_ADD, OP_WHOOK, 0,
										 OP_BUFWRITE, OP_WUNHOOK, OP_DUP, OP_BZ, 6, OP_DUP,
										 OP_BZNEG, 6, OP_SUB, OP_WHOOK, -11, OP_POP, OP_RHOOK, -22,
										 OP_JUMP, 666);
		opmeta_fixup((yyval.opm), 28, ofp_onexit);
		current_service->internal = 1;
	}
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 720 "grammar.y"
    {
		(yyval.opm) = opmeta_make(13, OP_ZERO, OP_RHOOK, 0, OP_RUNHOOK, OP_BUFINIT, 1024,
										 OP_BUFREAD, OP_BZNEG, 2, OP_RHOOK, -8, OP_JUMP, 666);
		opmeta_fixup((yyval.opm), 12, ofp_onexit);
		current_service->internal = 1;
	}
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 729 "grammar.y"
    {	(yyval.cp) = NULL;	}
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 735 "grammar.y"
    {
		if(current_service->port)
			stringlist_free(current_service->port);
		current_service->port = stringlist;
		stringlist = NULL;
	}
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 742 "grammar.y"
    {
		current_service->socktype = (yyvsp[(2) - (3)].num);
	}
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 746 "grammar.y"
    {
		current_service->backlog = (yyvsp[(2) - (3)].num);
	}
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 750 "grammar.y"
    {
		current_service->limit = (yyvsp[(2) - (3)].num);
	}
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 754 "grammar.y"
    {
		current_service->wait  = (yyvsp[(2) - (3)].num);
	}
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 758 "grammar.y"
    {
		current_service->disabled  = ! (yyvsp[(2) - (3)].num);
	}
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 762 "grammar.y"
    {
		if(current_service->interface)
			stringlist_free(current_service->interface);
		current_service->interface = stringlist;
		stringlist = NULL;
	}
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 769 "grammar.y"
    {
		current_service->opfixups[ofp_exec] = stringtab_add((yyvsp[(2) - (3)].cp));
		free((yyvsp[(2) - (3)].cp));
	}
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 776 "grammar.y"
    {
#ifdef HAVE_NET_BPF_H
		if(current_service->filter)
			free(current_service->filter);
		if(rl_readfile((yyvsp[(2) - (3)].cp), &current_service->filter, &current_service->filterlen))
			current_service->disabled++;
		free((yyvsp[(2) - (3)].cp));
#else
		RL_PFATAL(EX_DATAERR, _("ABORT - support for socket filter not compiled in"));
#endif
	}
    break;

  case 71:

/* Line 1806 of yacc.c  */
#line 795 "grammar.y"
    {
		current_service->rpcname = (yyvsp[(2) - (3)].cp);
	}
    break;

  case 72:

/* Line 1806 of yacc.c  */
#line 799 "grammar.y"
    {
		current_service->rpcvers = numlist;
		numlist = NULL;
	}
    break;

  case 75:

/* Line 1806 of yacc.c  */
#line 810 "grammar.y"
    {
		numlist_add(&numlist, (yyvsp[(1) - (1)].num));
	}
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 814 "grammar.y"
    {
		int i;

		if((yyvsp[(3) - (3)].num) >= (yyvsp[(1) - (3)].num))
			for(i = (yyvsp[(1) - (3)].num); i <= (yyvsp[(3) - (3)].num); i++)
				numlist_add(&numlist, i);
	}
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 828 "grammar.y"
    {
		current_service->r.rlim_cur = (yyvsp[(2) - (3)].rl);
	}
    break;

  case 80:

/* Line 1806 of yacc.c  */
#line 832 "grammar.y"
    {
		current_service->r.rlim_max = (yyvsp[(2) - (3)].rl);
	}
    break;

  case 83:

/* Line 1806 of yacc.c  */
#line 842 "grammar.y"
    {
		stringlist_add(&stringlist, (yyvsp[(1) - (1)].cp));
	}
    break;

  case 86:

/* Line 1806 of yacc.c  */
#line 852 "grammar.y"
    {
		stringlist_add(&stringlist, (yyvsp[(1) - (1)].cp));
	}
    break;

  case 87:

/* Line 1806 of yacc.c  */
#line 856 "grammar.y"
    {
		char tmp[20];

		snprintf(tmp, 19, "%ld", (yyvsp[(1) - (1)].num));
		tmp[19] = '\0';
		stringlist_add(&stringlist, strdup(tmp));
	}
    break;

  case 88:

/* Line 1806 of yacc.c  */
#line 866 "grammar.y"
    {
		(yyval.num) = rlimittab_add((yyvsp[(1) - (2)].rl), (yyvsp[(1) - (2)].rl));
	}
    break;

  case 89:

/* Line 1806 of yacc.c  */
#line 870 "grammar.y"
    {
		if((current_service->r.rlim_max != RLIM_INFINITY) &&
			 (current_service->r.rlim_cur > current_service->r.rlim_max)) {
			RL_PWARN(_("invalid resource limit"));
		}
		(yyval.num) = rlimittab_add(current_service->r.rlim_cur, current_service->r.rlim_max);
		current_service->r.rlim_cur = current_service->r.rlim_max = RLIM_INFINITY;
	}
    break;

  case 90:

/* Line 1806 of yacc.c  */
#line 881 "grammar.y"
    { (yyval.rl) = (rlim_t)(yyvsp[(1) - (1)].num); }
    break;

  case 91:

/* Line 1806 of yacc.c  */
#line 883 "grammar.y"
    { (yyval.rl) = RLIM_INFINITY; }
    break;

  case 92:

/* Line 1806 of yacc.c  */
#line 887 "grammar.y"
    {
#ifdef RLIMIT_CPU
		(yyval.num) = RLIMIT_CPU;
#else
		RL_PFATAL(EX_DATAERR, _("%s limit not available on this system"), "cpu");
#endif
	}
    break;

  case 93:

/* Line 1806 of yacc.c  */
#line 896 "grammar.y"
    {
#ifdef RLIMIT_FSIZE
		(yyval.num) = RLIMIT_FSIZE;
#else
		RL_PFATAL(EX_DATAERR, _("%s limit not available on this system"), "fsize");
#endif
	}
    break;

  case 94:

/* Line 1806 of yacc.c  */
#line 905 "grammar.y"
    {
#ifdef RLIMIT_DATA
		(yyval.num) = RLIMIT_DATA;
#else
		RL_PFATAL(EX_DATAERR, _("%s limit not available on this system"), "data");
#endif
	}
    break;

  case 95:

/* Line 1806 of yacc.c  */
#line 914 "grammar.y"
    {
#ifdef RLIMIT_STACK
		(yyval.num) = RLIMIT_STACK;
#else
		RL_PFATAL(EX_DATAERR, _("%s limit not available on this system"), "stack");
#endif
	}
    break;

  case 96:

/* Line 1806 of yacc.c  */
#line 923 "grammar.y"
    {
#ifdef RLIMIT_CORE
		(yyval.num) = RLIMIT_CORE;
#else
		RL_PFATAL(EX_DATAERR, _("%s limit not available on this system"), "core");
#endif
	}
    break;

  case 97:

/* Line 1806 of yacc.c  */
#line 932 "grammar.y"
    {
#ifdef RLIMIT_RSS
		(yyval.num) = RLIMIT_RSS;
#else
		RL_PFATAL(EX_DATAERR, _("%s limit not available on this system"), "rss");
#endif
	}
    break;

  case 98:

/* Line 1806 of yacc.c  */
#line 941 "grammar.y"
    {
#ifdef RLIMIT_NPROC
		(yyval.num) = RLIMIT_NPROC;
#else
		RL_PFATAL(EX_DATAERR, _("%s limit not available on this system"), "nproc");
#endif
	}
    break;

  case 99:

/* Line 1806 of yacc.c  */
#line 950 "grammar.y"
    {
#ifdef RLIMIT_NOFILE
		(yyval.num) = RLIMIT_NOFILE;
#else
		RL_PFATAL(EX_DATAERR, _("%s limit not available on this system"), "nofile");
#endif
	}
    break;

  case 100:

/* Line 1806 of yacc.c  */
#line 959 "grammar.y"
    {
#ifdef RLIMIT_MEMLOCK
		(yyval.num) = RLIMIT_MEMLOCK;
#else
		RL_PFATAL(EX_DATAERR, _("%s limit not available on this system"), "memlock");
#endif
	}
    break;

  case 101:

/* Line 1806 of yacc.c  */
#line 969 "grammar.y"
    {
		(yyval.uid) = getpwuid((yyvsp[(1) - (1)].num));
		endpwent();
	}
    break;

  case 102:

/* Line 1806 of yacc.c  */
#line 974 "grammar.y"
    {
		(yyval.uid) = getpwnam((yyvsp[(1) - (1)].cp));
		free((yyvsp[(1) - (1)].cp));
		endpwent();
	}
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 982 "grammar.y"
    {
		(yyval.gid) = getgrgid((yyvsp[(1) - (1)].num));
		endgrent();
	}
    break;

  case 104:

/* Line 1806 of yacc.c  */
#line 987 "grammar.y"
    {
		(yyval.gid) = getgrnam((yyvsp[(1) - (1)].cp));
		free((yyvsp[(1) - (1)].cp));
		endgrent();
	}
    break;

  case 105:

/* Line 1806 of yacc.c  */
#line 995 "grammar.y"
    {
		(yyval.num) = SOCK_STREAM;
		current_service->protoname = "tcp";
		current_service->proto = IPPROTO_TCP;
	}
    break;

  case 106:

/* Line 1806 of yacc.c  */
#line 1001 "grammar.y"
    {
		(yyval.num) = SOCK_DGRAM;
		current_service->protoname = "udp";
		current_service->proto = IPPROTO_UDP;
	}
    break;

  case 107:

/* Line 1806 of yacc.c  */
#line 1009 "grammar.y"
    {
		current_service->family = PF_INET;
	}
    break;

  case 108:

/* Line 1806 of yacc.c  */
#line 1013 "grammar.y"
    {
#ifdef HAVE_SOCKADDR_IN6
		current_service->family = PF_INET6;
#else
		RL_PWARN(_("ipv6 support is not compiled in"));
		current_service->family = PF_INET;
#endif
	}
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 1024 "grammar.y"
    {
		(yyval.num) = (yyvsp[(1) - (1)].num);
	}
    break;

  case 110:

/* Line 1806 of yacc.c  */
#line 1028 "grammar.y"
    {
		(yyval.num) = (-(yyvsp[(2) - (2)].num));
	}
    break;

  case 111:

/* Line 1806 of yacc.c  */
#line 1034 "grammar.y"
    {
		(yyval.num) = 1;
	}
    break;

  case 112:

/* Line 1806 of yacc.c  */
#line 1038 "grammar.y"
    {
		(yyval.num) = 0;
	}
    break;



/* Line 1806 of yacc.c  */
#line 3047 "grammar.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 1042 "grammar.y"


void yyerror(char *str) {
	RL_PFATAL(EX_DATAERR, _("ABORT - %s"), str);
}

int yywrap() {
	fclose(yyin);
	if(numfiles) {
		while(++curfile < numfiles) {
			if((yyin = fopen(files[curfile], "r"))) {
				curfile_name = files[curfile];
				curfile_line = 1;
				return 0;
			} else {
				curfile_name = NULL;
				RL_PWARN(_("cannot open file %s (%s)"), files[curfile],
						strerror(errno));
			}
		}
	}
	return 1;
}

static struct service *service_new() {
	struct service *p = (struct service *)malloc(sizeof(*p));

	if (!p)
		rl_fatal(EX_SOFTWARE, _("ABORT - Can't allocate memory"));
	memset(p, 0, sizeof(*p));
	return p;
}

void services_free() {
	if(rl_cleanups) {
		rlp_cleanup(rl_cleanups);
		rl_cleanups = NULL;
	}
}

static void validate_service(struct service *s) {
	if(!s->name) {
		RL_PWARN(_("service without name"));
		s->disabled++;
		return;
	}

 if (!has_flag(s, FLAG_USER)) {
		RL_PWARN(_("user is not set for service %s"), s->name);
		s->disabled++;
		return;
 }

	if (s->wait && s->limit != 1) {
		if (s->limit != defaults->limit)
			RL_PWARN(_("ignoring `instances %d' directive for service %s, because `wait' was also given"),
										s->limit, s->name);
		s->limit = 1;
	}

	if(s->rpcvers) {
		char *rpcname = s->name;
		struct rpcent *rep;

		if(s->rpcname)
			rpcname = s->rpcname;
		rep = getrpcbyname(rpcname);
		if(!rep) {
			RL_PWARN(_("can't find rpc service %s for service %s"),
							rpcname, s->name);
			s->disabled++;
		} else {
			s->rpcnum = rep->r_number;
		}
		endrpcent();
	}
}

static int bind_ports() {
	int fd;
	long opt = 1;
	struct stringlist *portp;
	struct stringlist *ifp;
#ifdef HAVE_GETADDRINFO
	struct addrinfo hints;
	struct addrinfo *results = NULL, *ai;
	int ret;
#else
	void *addrbuf;
	int portnum;
	char *ctmp;
#endif
	char *port, *addr;
	char *lasterror, *errfunc = NULL;
	int succeeded;
	fd_set fds;
	int n_fds;

	int family, socktype, protocol;
	socklen_t saddrlen;
	struct sockaddr *saddr = NULL;

	FD_ZERO(&fds);
	n_fds = 0;
	ifp = current_service->interface;
	do {
		struct stringlist fallback = { !current_service->rpcnum ? current_service->name : "0" , NULL };

		addr = ifp ? ifp->str : NULL;
		portp = current_service->port;
		if(!portp)
			portp = &fallback;
		do {
			lasterror = NULL;
			succeeded = 0;

			port = portp->str;
#ifdef HAVE_GETADDRINFO
			memset(&hints, 0, sizeof(hints));
			hints.ai_flags = AI_PASSIVE;
			hints.ai_family = current_service->family;
			hints.ai_socktype = current_service->socktype;
			hints.ai_protocol = current_service->proto;
			if(results)
				freeaddrinfo(results);
			results = NULL;
			if((ret = getaddrinfo(addr, port, &hints, &results))) {
#ifdef HAVE_GAI_STRERROR
				RL_PWARN(_("getaddrinfo(%s, %s) failed: %s"), addr, port,
								gai_strerror(ret));
#else
				RL_PWARN(_("getaddrinfo(%s, %s) failed: %s"), addr, port,
								_("for reasons unknown") );
#endif
				continue;
			}
			ai = results;
			do {
				family = ai->ai_family;
				socktype = ai->ai_socktype;
				protocol = ai->ai_protocol;
				saddr = ai->ai_addr;
				saddrlen = ai->ai_addrlen;
#else
				portnum = strtoul(port, &ctmp, 10);
				if(*ctmp) {
					portnum = getservport(port, current_service->protoname);
					if(portnum == -1) {
						RL_PWARN(_("Failed to resolve %s, protocol %s"),
										current_service->proto, port);
						continue;
					}
				}
				family = current_service->family;
				socktype = current_service->socktype;
				protocol = current_service->proto;
				if(saddr) {
					free(saddr);
					saddr = NULL;
				}
				switch(family) {
					struct sockaddr_in *sin;
#ifdef HAVE_SOCKADDR_IN6
					struct sockaddr_in6 *sin6;
#endif

					case PF_INET:
						saddrlen = sizeof(struct sockaddr_in);
						sin = (struct sockaddr_in *)malloc(saddrlen);
						if (!sin)
							rl_fatal(EX_SOFTWARE, _("ABORT - Can't allocate memory"));
						addrbuf = &sin->sin_addr.s_addr;
						sin->sin_family = current_service->family;
						sin->sin_port = htons(portnum);
						sin->sin_addr.s_addr = INADDR_ANY;
						saddr = (struct sockaddr *)sin;
						break;
#ifdef HAVE_SOCKADDR_IN6
					case PF_INET6:
						saddrlen = sizeof(struct sockaddr_in6);
						sin6 = (struct sockaddr_in6 *)malloc(saddrlen);
						if (!sin6)
							rl_fatal(EX_SOFTWARE, _("ABORT - Can't allocate memory"));
						addrbuf = &sin6->sin_addr.s_addr;
						sin6->sin6_family = current_service->family;
						sin6->sin6_port = htons(portnum);
						sin6->sin6_addr = IN6ADDR_ANY_INIT;
						saddr = (struct sockaddr *)sin6;
						break;
#endif
					default:
						RL_PFATAL(EX_SOFTWARE, _("funky family in service"));
				}
				if(addr) {
					if(
#ifdef HAVE_INET_PTON
						 inet_pton(family, addr, addrbuf)
#else
																/* this cast is a pain */
						 (*(unsigned int *)addrbuf = inet_addr(addr)) == -1
#endif
						 ) {
						RL_PWARN(_("bad address %s in service %s"), addr,
										current_service->name);
						free(saddr);
						saddr = NULL;
						continue;
					}
				}
#endif
				if((fd = socket(family, socktype, protocol)) < 0) {
					lasterror = strerror(errno);
					errfunc = "socket()";
					goto out;
				}
				if(setsockopt(fd, SOL_SOCKET, SO_REUSEADDR, &opt, sizeof(opt))) {
					RL_PWARN(_("setsockopt(%d, SOL_SOCKET, SO_REUSEADDR, 1) failed for service %s (%s)"),
									fd, current_service->name, strerror(errno));
				}
#ifdef HAVE_NET_BPF_H
				if(current_service->filter) {
					struct bpf_program bp;

					bp.bf_len = current_service->filterlen / sizeof(struct bpf_insn);
					bp.bf_insns = current_service->filter;
					if(setsockopt(fd, SOL_SOCKET, SO_ATTACH_FILTER, &bp, sizeof(bp))) {
						lasterror = strerror(errno);
						close(fd);
						errfunc = "setsockopt(..., SO_ATTACH_FILTER)";
						goto out;
					}
				}
#endif
				if(bind(fd, saddr, saddrlen) < 0) {
					lasterror = strerror(errno);
					close(fd);
					errfunc = "bind()";
					goto out;
				}
				if(current_service->rpcnum) {
					struct numlist *vers = current_service->rpcvers;
					struct rl_cleanup *p;
					struct sockaddr saddr2;

					if (getsockname(fd, &saddr2, &saddrlen) == -1) {
						RL_PWARN(_("getsockname(%d) failed for service %s"), fd, current_service->name);
						memcpy(&saddr2, saddr, sizeof(struct sockaddr));
					}

					do {
						if(!pmap_set(current_service->rpcnum, vers->num,
												 protocol,
												 ntohs(((struct sockaddr_in *)&saddr2)->sin_port)))
							RL_PWARN(_("pmap_set(%d, %d, %d, %d) failed for service %s"),
											current_service->rpcnum, vers->num,
											protocol, ntohs(((struct sockaddr_in *)&saddr2)->sin_port),
											current_service->name);
					} while((vers = vers->next));
					p = (struct rl_cleanup *)malloc(sizeof(struct rl_cleanup));
					if (!p)
						rl_fatal(EX_SOFTWARE, _("ABORT - Can't allocate memory"));
					p->next = rl_cleanups;
					p->data =	(struct rlc_unrpc *)malloc(sizeof(struct rlc_unrpc));
					if (!p->data)
						rl_fatal(EX_SOFTWARE, _("ABORT - Can't allocate memory"));
					p->type = RLC_UNRPC;
					((struct rlc_unrpc *)p->data)->vers = NULL;
					numlist_copy(&(((struct rlc_unrpc *)p->data)->vers), current_service->rpcvers);
					((struct rlc_unrpc *)p->data)->prog =	current_service->rpcnum;
					/* current_service->rpcvers = NULL;*/ /* caused segfault in the next iteration
																									 of do...while(ai=ai->ai_next) loop */
					rl_cleanups = p;
				}
				FD_SET(fd, &fds);
				if(socktype == SOCK_STREAM) {
					if(listen(fd, current_service->backlog)) {
						lasterror = strerror(errno);
						close(fd);
						errfunc = "listen(fd)";
						goto out;
					}
				}
				if(fcntl(fd, F_SETFD, 1)) {
					lasterror = strerror(errno);
					errfunc = "fcntl(fd, F_SETFD, 1)";
					close(fd);
					goto out;
				}
				if(fcntl(fd, F_SETFL, O_NDELAY)) {
					lasterror = strerror(errno);
					close(fd);
					errfunc = "fcntl(fd, F_SETFL, O_NDELAY)";
					goto out;
				}
				n_fds++;
				succeeded++;
			out:
#ifdef HAVE_GETADDRINFO
				continue;
			} while((ai = ai->ai_next));
#endif
			if(!succeeded && lasterror)
				RL_PWARN(_("%s failed for service %s: %s"),
								errfunc, current_service->name, lasterror);
		} while(portp && (portp = portp->next));
	} while(ifp && (ifp = ifp->next));
	stringlist_free(current_service->port);
	current_service->port = NULL;
	stringlist_free(current_service->interface);
	current_service->interface = NULL;
	numlist_free(current_service->rpcvers);
	current_service->rpcvers = NULL;
#ifdef HAVE_GETADDRINFO
	if(results) {
		freeaddrinfo(results);
		results = NULL;
	}
#else
	if(saddr) {
		free(saddr);
		saddr = NULL;
	}
#endif
	if (!n_fds)
		current_service->disabled++;
	return fdsettab_add(&fds);
}

static int add_user_group(const struct service* s, struct opmetalist * l)
{
	struct opmeta *o = NULL;
 	if (has_flag(s, FLAG_USER))
	{
		o = opmeta_make(2, OP_SUID, 666);
		opmeta_fixup(o, 1, ofp_setuid);
		if(opmetalist_add(l, o)) {
				RL_PWARN(_("opcode resolving problem"));
				return 0;
		}
  }

	if (has_flag(s, FLAG_USER) || (has_flag(s, FLAG_GROUP)))
	{
				o = opmeta_make(2, OP_SGID, 666);
				opmeta_fixup(o, 1, ofp_setgid);
				if(opmetalist_add(l, o)) {
					RL_PWARN(_("opcode resolving problem"));
				  return 0;
				}
  }

	if (has_flag(s, FLAG_USER) && has_flag(s, FLAG_INITGROUPS))
  {
			o = opmeta_make(3, OP_INITGR, 666, 666);
			opmeta_fixup(o, 1, ofp_iuser);
			opmeta_fixup(o, 2, ofp_supgid);
			if(opmetalist_add(l, o)) {
				RL_PWARN(_("opcode resolving problem"));
			 return 0;
		}
	}
  return 1;
}

static void service_free(struct service *s) {
	if(s->name) {
		free(s->name);
		s->name = NULL;
	}
	stringlist_free(s->port);
	s->port = NULL;
	stringlist_free(s->interface);
	s->interface = NULL;
	if(s->rpcname) {
		free(s->rpcname);
		s->rpcname = NULL;
	}
	if(s->rpcvers) {
		numlist_free(s->rpcvers);
		s->rpcvers = NULL;
	}
#ifdef HAVE_CAPABILITIES
	if(s->caps) {
		cap_free(&s->caps);
		s->caps = NULL;
	}
#endif
#ifdef HAVE_NET_BPF_H
	if(s->filter) {
		free(s->filter);
		s->filter = NULL;
		s->filterlen = 0;
	}
#endif
}

static void service_copy(struct service *to, struct service *from) {
	memcpy(to, from, sizeof(*to));
	to->name = NULL;
	to->port = NULL;
	to->interface = NULL;
	stringlist_copy(&to->port, from->port);
	stringlist_copy(&to->interface, from->interface);
	to->rpcname = from->rpcname ? strdup(from->rpcname) : NULL;
	to->rpcvers = NULL;
	numlist_copy(&to->rpcvers, from->rpcvers);
#ifdef HAVE_LIBCAP
	to->caps = from->caps ? cap_dup(from->caps) : NULL;
#endif
#ifdef HAVE_NET_BPF_H
	if(from->filter) {
		to->filter = malloc(from->filterlen);
		if (!to->filter)
			rl_fatal(EX_SOFTWARE, _("ABORT - Can't allocate memory"));
		memcpy(to->filter, from->filter, from->filterlen);
	}
#endif
}

static struct logdata *logdata_get(char *name) {
	struct logdata *ptr = logdatas;

	if(!ptr)
		return NULL;
	do {
		if(!strcmp(name, ptr->name))
			return ptr;
	} while((ptr = ptr->next));
	return NULL;
}

static void logdatas_free() {
	struct logdata *p, *q;

	p = logdatas;
	while(p) {
		q = p->next;
		if(p->name)
			free(p->name);
		if(p->path)
			free(p->path);
		free(p);
		p = q;
	}
	logdatas = NULL;
}

static struct logdata *logdata_new() {
	struct logdata *ptr = (struct logdata *)malloc(sizeof(*ptr));

	if (!ptr)
		rl_fatal(EX_SOFTWARE, _("ABORT - Can't allocate memory"));

	memset(ptr, 0, sizeof(*ptr));
	ptr->index = -1;
	ptr->mode =
#ifdef S_IRUSR
		S_IRUSR|S_IWUSR|S_IRGRP
#else
		0640
#endif
		;
	ptr->uid = -1;
	ptr->gid = -1;
	return ptr;
}

void parse() {
	void freebufs();

	numlist = NULL;
	userdata = NULL;
	newuserdata(&userdata);
	pidtab_fixup();
	all_unhook();
	logtabs_free();
	argvtabs_free();
	rlimittabs_free();
	services_free();
	stringtabs_free();
	buftabs_free();
	oplisttabs_free();
#ifdef HAVE_CAPABILITIES
	captabs_free();
#endif
	semaphores_free();
	fdsettabs_free();
	if(strcmp(rl_config, "-") || !rl_debug) {
		if(!(yyin = fopen(rl_config, "r"))) {
			RL_PFATAL(EX_NOINPUT, _("fopen(%s) failed, aborting"), rl_config);
		} else {
			curfile_name = rl_config;
			curfile_line = 1;
		}
	}

	logcur = logdata_new();
	current_service = service_new();
	defaults = service_new();
#ifdef HAVE_GETADDRINFO
	defaults->family = PF_UNSPEC;
#else
	defaults->family = PF_INET;
#endif
	defaults->socktype = SOCK_STREAM;
	defaults->protoname = "tcp";
	defaults->proto = IPPROTO_TCP;
	defaults->backlog = 5;
	defaults->limit = 40;
	defaults->r.rlim_cur = RLIM_INFINITY;
	defaults->r.rlim_max = RLIM_INFINITY;
	defaults->wait = 0;


	defaults->opfixups[ofp_exec] = -1;

	defaults->opfixups[ofp_iname] = -1;
	defaults->opfixups[ofp_parent] = -1;
	defaults->opfixups[ofp_iuser]  = -1;
	defaults->sflags =  0;
	defaults->opfixups[ofp_supgid] = -1;
	defaults->opfixups[ofp_setgid] = -1;
	defaults->opfixups[ofp_setuid] = -1;
	service_copy(current_service, defaults);
  opml_defaults = opmetalist_new();
	yyparse();
	freebufs();
	service_free(defaults);
	free(defaults);
	defaults = NULL;
	logdatas_free();
	free(logcur);
	logcur = NULL;
	service_free(current_service);
	free(current_service);
	current_service = NULL;
	for(curfile = 0; curfile < numfiles; curfile++) {
		free(files[curfile]);
		files[curfile] = NULL;
	}
	free(files);
	files = NULL;
	clearuserdata(&userdata);
	free(userdata);
}

static void pidtab_fixup() {
	struct pidtab *p;
	int i;

	for(i = 0; i < 8; i++) {
		p = pidtabs[i].next;
		while(p) {
			if(p->inst)
				inst_free(p->inst);
			p->inst = NULL;
			p = p->next;
		}
	}
}

#ifndef HAVE_GETADDRINFO
static int getservport(char *str, char *proto) {
	struct servent *foo;
	int ret = -1;

	foo = getservbyname(str, proto);
	if(foo)
		ret = ntohs(foo->s_port);
	endservent();
	return ret;
}
#endif

static void add_directory(char *dir, char *match, char *ignore) {
	DIR *d;
	struct dirent *de;
	regex_t rmatch, rignore;
	char err[128];
	int e;
	struct stat st;
	char *file;

	if(match)
		if((e = regcomp(&rmatch, match, REG_EXTENDED|REG_NOSUB))) {
			regerror(e, &rmatch, err, 127);
			RL_PWARN(_("regexp compile failed for directory %s: %s"),
							dir, err);
		}
	if(ignore)
		if((e = regcomp(&rignore, ignore, REG_EXTENDED|REG_NOSUB))) {
			regerror(e, &rignore, err, 127);
			RL_PWARN(_("regexp compile failed for directory %s: %s"),
							dir, err);
		}

	if((d = opendir(dir))) {
		while((de = readdir(d))) {
			if(match)
				if(regexec(&rmatch, de->d_name, 0, NULL, 0))
					continue;
			if(ignore)
				if(!regexec(&rignore, de->d_name, 0, NULL, 0))
					continue;
			if(de->d_name[0] != '.') {
				file = malloc(strlen(dir) + NAMLEN(de) + 2);
				if (!file)
					rl_fatal(EX_SOFTWARE, _("ABORT - Can't allocate memory"));
				file[0] = '\0';
				strcat(file, dir);
				strcat(file, "/");
				strcat(file, de->d_name);
				if(stat(file, &st) || S_ISDIR(st.st_mode)) {
					RL_PWARN(_("file %s does not exists or"
						 " is a directory"), file);
					free(file);
					continue;
				}
				files = (char **)realloc(files, ++numfiles * sizeof(char *));
				if (!files)
					rl_fatal(EX_SOFTWARE, _("ABORT - Can't allocate memory"));
				files[numfiles - 1] = file;
			}
		}
	} else {
		RL_PFATAL(EX_NOINPUT, _("Directory %s open failed (%s)"), dir,
			strerror(errno));
	}
	closedir(d);
	free(dir);
	if(match) {
		free(match);
		regfree(&rmatch);
	}
	if(ignore) {
		free(ignore);
		regfree(&rignore);
	}
}

int chargen_buffer() {
	static int cb = -1;
	char *b = "01234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ\r\n";

	if(cb == -1)
		cb = buftab_addbuf(b, strlen(b));
	return cb;
}


/* vim: set ts=2: */

